#!/usr/bin/perl
#
# Based on Gtk2/t/GtkFileChooserDialog.t
#
BEGIN { require './t/inc/setup.pl' }

use strict;
use warnings;

plan tests => 5;

# This is necessary for now until GtkResponseType
# is figured out.
use constant OK => -5;
use constant CANCEL => -6;

my $dialog = Gtk3::FileChooserDialog->new ('some title', undef, 'save',
                                           'gtk-cancel' => CANCEL,
                                           'gtk-ok' => OK);

isa_ok ($dialog, 'Gtk3::FileChooserDialog');
ginterfaces_ok($dialog);

is ($dialog->get_action, 'save', 'get_action return test');

isa_ok ($dialog, 'Gtk3::FileChooserDialog');
isa_ok ($dialog, 'Gtk3::FileChooser');

sub ginterfaces_ok {
  my ($object_or_package) = @_;
  my $type = ref $object_or_package || $object_or_package;
  my $i = 0;
  my @ifaces = Glib::Type->list_interfaces ($type);
  foreach my $iface (@ifaces) {
    if ($object_or_package->isa ($iface)) {
      $i++;
    } else {
      warn "GType $type is supposed to implement $iface, "
      . "but \@type\::ISA doesn't contain $iface!\n";
    }
  }
  is ($i, scalar(@ifaces), "GInterface versus \@ISA for $type");
}


__END__

Copyright (C) 2003 by the gtk2-perl team (see the file AUTHORS for the
full list).  See LICENSE for more information.
